'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_LOCALE = 'en';
var mapStateToProps = function mapStateToProps(_ref) {
  var locale = _ref.locale;
  return { locale: locale };
};

var LocaleProvider = (_dec = (0, _reactRedux.connect)(mapStateToProps), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(LocaleProvider, _Component);

  function LocaleProvider() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, LocaleProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = LocaleProvider.__proto__ || (0, _getPrototypeOf2.default)(LocaleProvider)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      currentLocale: undefined,
      currentLocaleData: undefined
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(LocaleProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _state = this.state,
          currentLocale = _state.currentLocale,
          currentLocaleData = _state.currentLocaleData;

      return {
        i18n: {
          locale: currentLocale,
          localeData: currentLocaleData
        }
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.updateLocaleData(this.props, this.state);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {
      this.updateLocaleData(nextProps, nextState);
    }
  }, {
    key: 'getLocaleFromProps',
    value: function getLocaleFromProps(props) {
      var localeData = props.localeData,
          locale = props.locale;

      return localeData[locale] ? locale : DEFAULT_LOCALE;
    }
  }, {
    key: 'updateLocaleData',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(props, state) {
        var localeData, locale, currentLocaleData;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                localeData = props.localeData;
                locale = this.getLocaleFromProps(props);

                if (!(locale !== state.currentLocale)) {
                  _context.next = 12;
                  break;
                }

                currentLocaleData = localeData[locale];

                if (!(typeof currentLocaleData !== 'function')) {
                  _context.next = 8;
                  break;
                }

                this.setState({
                  currentLocale: locale,
                  currentLocaleData: currentLocaleData
                });
                _context.next = 12;
                break;

              case 8:
                _context.next = 10;
                return currentLocaleData();

              case 10:
                currentLocaleData = _context.sent;

                if (this.getLocaleFromProps(this.props) === locale) {
                  this.setState({
                    currentLocale: locale,
                    currentLocaleData: currentLocaleData
                  });
                }

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateLocaleData(_x, _x2) {
        return _ref3.apply(this, arguments);
      }

      return updateLocaleData;
    }()
  }, {
    key: 'render',
    value: function render() {
      var currentLocale = this.state.currentLocale;


      if (!currentLocale) {
        return null;
      }

      return _react.Children.only(this.props.children);
    }
  }]);
  return LocaleProvider;
}(_react.Component), _class2.propTypes = {
  locale: _propTypes2.default.string.isRequired, // eslint-disable-line
  children: _propTypes2.default.any.isRequired,
  localeData: _propTypes2.default.object // eslint-disable-line
}, _class2.defaultProps = {
  localeData: {}
}, _class2.childContextTypes = {
  i18n: _propTypes2.default.object.isRequired
}, _temp2)) || _class);
exports.default = LocaleProvider;