'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propTypes = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _memoize = require('lodash/memoize');

var _memoize2 = _interopRequireDefault(_memoize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var memoizedPluralForm = (0, _memoize2.default)(function (locale, localeData) {
  var messages = localeData.messages;


  if (messages) {
    // eslint-disable-next-line
    return Function('n', 'nplurals', 'plural', messages[''].plural_forms + ' return plural;');
  }

  return function (n) {
    return n === 1 ? 0 : 1;
  };
});

var propTypes = exports.propTypes = {
  locale: _propTypes2.default.string,
  gettext: _propTypes2.default.func,
  ngettext: _propTypes2.default.func,
  pgettext: _propTypes2.default.func,
  npgettext: _propTypes2.default.func,
  i18n: _propTypes2.default.object,
  localizedRef: _propTypes2.default.func
};

exports.default = function (WrappedComponent) {
  var _class, _temp2, _initialiseProps;

  return _temp2 = _class = function (_Component) {
    (0, _inherits3.default)(LocalizedComponent, _Component);

    function LocalizedComponent() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, LocalizedComponent);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = LocalizedComponent.__proto__ || (0, _getPrototypeOf2.default)(LocalizedComponent)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(LocalizedComponent, [{
      key: 'getPluralForm',
      value: function getPluralForm(n) {
        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return memoizedPluralForm(locale, localeData)(n);
      }
    }, {
      key: 'getMessage',
      value: function getMessage(message, context) {
        var _getLocaleData = this.getLocaleData(),
            messages = _getLocaleData.messages;

        if (messages) {
          var messageId = context ? context + '\x04' + message : message;
          return messages[messageId] || null;
        }

        return null;
      }
    }, {
      key: 'getLocale',
      value: function getLocale() {
        var locale = this.context.i18n.locale;

        return locale;
      }
    }, {
      key: 'getLocaleData',
      value: function getLocaleData() {
        var localeData = this.context.i18n.localeData;

        return localeData || {};
      }
    }, {
      key: 'replaceInjections',
      value: function replaceInjections(input, injections) {
        return input.replace(/{([0-9])}/g, function (match, index) {
          return injections[index];
        });
      }
    }, {
      key: 'render',
      value: function render() {
        var localizedRef = this.props.localizedRef;

        var locale = this.getLocale();
        var localeData = this.getLocaleData();
        return (0, _react.createElement)(WrappedComponent, (0, _extends3.default)({}, this.props, {
          locale: locale,
          gettext: this.gettext,
          ngettext: this.ngettext,
          pgettext: this.pgettext,
          npgettext: this.npgettext,
          i18n: localeData.additions,
          ref: localizedRef
        }));
      }
    }]);
    return LocalizedComponent;
  }(_react.Component), _class.propTypes = {
    localizedRef: _propTypes2.default.func
  }, _class.contextTypes = {
    i18n: _propTypes2.default.object.isRequired
  }, _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.gettext = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _this2.pgettext.apply(_this2, [undefined].concat(args));
    };

    this.pgettext = function (context, input) {
      for (var _len3 = arguments.length, injections = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        injections[_key3 - 2] = arguments[_key3];
      }

      var message = _this2.getMessage(input, context);
      var output = void 0;

      if (message) {
        output = (0, _isArray2.default)(message) ? message[0] : message;
      } else {
        output = input;
      }

      return _this2.replaceInjections(output, injections);
    };

    this.ngettext = function () {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return _this2.npgettext.apply(_this2, [undefined].concat(args));
    };

    this.npgettext = function (context, singular, plural, n) {
      for (var _len5 = arguments.length, injections = Array(_len5 > 4 ? _len5 - 4 : 0), _key5 = 4; _key5 < _len5; _key5++) {
        injections[_key5 - 4] = arguments[_key5];
      }

      var message = _this2.getMessage(singular, context);
      var output = void 0;

      if (message) {
        output = message[_this2.getPluralForm(n)];
      } else {
        output = [singular, plural][_this2.getPluralForm(n)];
      }

      return _this2.replaceInjections(output, injections);
    };
  }, _temp2;
};